#!/bin/sh

SRC=../www/img
SIZE=500

# transform path to /img/*/.thumb/
pathtrans() {
  filename=$(basename "${1%.*}")
  pathname="${1%/*}"
  if [ ! -d ${pathname}/.thumb ]; then
    mkdir ${pathname}/.thumb/
  fi
  echo "${pathname}/.thumb/${filename}.png"
}

# generate thumbnails in /img/*/.thumb/
resize() {
  output=$(pathtrans $1)
  if echo $1 | grep -e .gif -e .zip > /dev/null; then
    return
  fi
  if [ ! -f ${output} ]; then
    echo "Stripping metadata from $1"
    convert "$1" -strip "$1"
    echo "Generating thumbnail for $1"
    convert "$1" -strip -auto-orient -resize ${SIZE} -dither FloydSteinberg -colors 16 ${output}
  fi
}

if [ -z "$1" ]; then
  echo "usage: $0 [build|clean]"
else
  case $1 in
    "build")
      echo "Updating thumbnails cache"
      for x in $(find ${SRC}/*/*); do resize "$x"; done;;
    "clean")
      echo "Cleaning thumbnails cache"
      rm -rf ${SRC}/*/.thumb
      echo "Cleaned";;
  esac
fi
